Changes for 0.9.0.2

* fix bug [ 1640596 ] 0.9.0.1 Revised Map Wrap Issue (sgb)

* Fix bug where dissapearing networks players would not be removed from the game (sgb)

* allow lobby server to ping clients to ensure the are still there (sgb)

Changes for 0.9.0.1

* Adjusted British starting units (Jason Clark)

* fixed infantry defense in Classic (sgb)

Changes for 0.9

* improve great war map (Jason Clark)

* improve great war african markers (Jason Clark)

* fixed orientation of french zeppelin in great war (Jason Clark)

* In great war, the US now has a starting transport, 1 inf and 1 cav.  1 us cruiser removed. (Jason Clark)

* In great war, removed connection between Tanga and Weidmannshiel. (Jason Clark)

* focus on action button when battle window is activated (sgb)

* lobby server checks client's computer is network accessble when client hosts a game (sgb)

* fix [ 1611289 ] map scrolling bug (sgb)

* client only waits 10 seconds for connection to servr to be made before aborting (sgb)

Changes for 0.8.6

* fix infantry in classic (sgb)

* make convoy zones stand out better (sgb)

* read output of exec'd lobby games (sgb)

* Saved games in user.home/triplea (not .triplea) for linux and user.home/Documents/triplea for mac (sgb)

* better logic for finding local ip address (sgb)

* fix loby where clients could not find real server address (sgb)

Changes for 0.8.5

* allow neutrals to have different unit types (sgb)

* fix bugs where all bombers in lhtr defend at 2 (sgb)

* update big world map (surtur2)

* alt click/unclick selects 1/10 the type (Nate)

* allow weak ai to move into empty nuetral territories (Nate)

* make dialog clearer for planes can't land (sgb)

* handle marti dice server error messages (sgb,clausewitz)

* allow setting of lobby server lookup url in a file called lobby.properties with a key server in the root triplea directory (sgb)

* fix max select when more than one type of unit present (sgb)

* fix some click to continue to press sapce to continue (sgb)

Changes for 0.8.4

* change click to continue text to press space to continue on battle screens (sgb)

* add an option in battle calculator that at least 1 attacking land unit must survive (sgb)

* fix transport capactity in europe, add connection between adriatic and central med, make saudia arabia nuetral (sgb)

* change network to use nio (sgb)

* fix bug where units originally in a sea zone with a submerged sub that is attacked by another unit cant leave the sea zone (sgb)

* show battle calculator on current territory when pressing ctrl B (sgb)

* ctrl+ and ctrl - zoom in and out (sgb)

* mark lhtr as complete. low luck rules for heavy bombers still need to be added for all versions (sgb)

* allow fighters to hover in sea zone where carriers can be produced under them for lhtr (sgb)

* move dice server config into properties file (sgb)

* allow controlling of name placements using name_place.txt (sgb)

* fix sea zone boundaries when map is scaled (sgb)

* add great_war mode (surtur2 and Triplelk)

* update triplea_linux.sh (Daniel Roethlisberger)

* show messages when people join/leave chat (sgb)

* fix scroll bug where map would jump when mouse scrolled in non wrappable maps (sgb)

* make convoy zones more transparent (sgb)

* fix neutral fighting bug (sgb)

* fix spelling mstakes in classic map (sgb, RogerCooper)

* add max button to place dialog where number of units that can be placed is limited (sgb)

* fix bug [ 1563239 ] Bad scroll increment for scrollbars (sgb)

* fix bug  [ 1563227 ] Continue button does not show up (sgb)

Changes for 0.8.3

* make odds calculator use MustFightBattle, update ui (sgb)

* allow scaling of auto placement finder.  On the command line, type the scale after the command, 
eg "java -classpath triplea.jar util/image/AutoPlacementFinder 0.5" (sgb)

* add map decoration images.  create a file called decorations.txt in the map directory.  The format is the same as place.txt, with an image name, then list of points where
the image should be drawn (multiple points are fine).  The image name should be the name of a file in the misc image folder (the same folder that has vc.png) (sgb)

* disable territory name drawing for territories listed in map.properties with a property like dont_draw_territory_names=Germany,Japan (sgb)

* allow for map scaling (sgb)

* let ai play in multiplayer games (sgb)

* fix [ 1533252 ] problem clearing out pbem (sgb)

* make the game look better on a mac (sgb)

* better factory images (eleazar)

* lhtr hb rules (not sure if low luck is correct) (sgb)

* lobby server/client (sgb)

* you can kick players out of a game on startup screen (sgb)

* add odds calculator (zengland)

* fix bug [ 1505192 ] air land in conquered territory (sgb)

* allow networked games to be password protected (sgb)

* for mac and linux, save games in home folder (sgb)

* add convoy centers in europe map (iron cross)

* put saved games in users home directory (sgb)

* fix misspelt territory names in revised and lhtr (Jeffrey Henning)

* add lhtr victory citries (sgb)

* super subs defend at 3 in lhtr (sgb)

* make lhtr aa guns not fire in non combat move (sgb)

* pacific and europe map fixes (Opurt, FlyingSpaghettiMonster)

Changes for 0.8.2.1

* fix installer with embedded java to actually use the embedded java (sgb)

* default sound to off (sgb)

* fix nz territory in four if by sea (rod the god)

Changes for 0.8.2

* fix bug where observers joining mid game may ignore some updates (sgb)

* lock game data before switching to history (sgb)

* fix bug where casualty selection would sometimes appear before the battle panel (sgb)

* fix bug where naval bombardment doesnt work for the first player to fight in round 0 (sgb)

* change two if by sea to four if by sea (rod the god)

* remove nuetral player in capture the flag (sgb)

Changes for 0.8.1

* add capture the flag map (iron cross)

* let ai place in places other than the capitol if not all units can be placed in the capitol (sgb)

* fix move bug when no units are selected with pop up (sgb)

* fix "Not enough units in starting territory" bug when hitting done (sgb)

* documentation updates (sgb)

* fix history update bug in multiplayer (sgb)

* fix bug where if A has 1 carrier and no fighters in a sea zone and is allied to B with 1 carrier and 3 fighters in the saem sea zone, when A moves his carrier out of the sea zone, B's 1 fighter doesnt move with it (if A moved his carrier in the sea zone after B moved his carrier into the sea zone)

* show strategic bombing raid casualty notification (sgb)

* fixed bug where deselecting game-confirm enemy casualties would also stop confirming your own automatically selected casualties (sgb)

* europe and pacific map fixes (zero pilot)

Changes for 0.8

* save last used map skin and unit size (beagle)

* add next and back buttons to history (sgb)

* renamed game xml files (sgb)

* moves canal info to the xml file (if you have a mod based on revised or classic, canals will be broken unless you add them in the xml, do a search for canal in classic.xml or revised.xml to see how it is done) (sgb)

* fix bug where aa guns in retaken allied capitols werent reverting to there original owner (sgb)

* replace random ai with weak ai (sgb)

* fix pbem saved emails not always showing up on the start screen (sgb)

* highlight units on mouse over when moving (sgb)

Change for 0.7.5

* when changing to a skin that has relief images, always show the relief images (sgb)

* add destroyer production to europe map (sgb)

* fix map skins in zip files on windows (sgb)

* map skins must use - not : to seperate skin from map names (eg revised-Coal, not revised:Coal).  Windows doesnt allow : in file names (sgb)

* if user presses done when no moves were made, confirm that they do not want to move (sgb)

* fix bug [ 1440134 ] rockets shouldnt move after firing (sgb)

* add tripleawarclub dice server (clausewitz, pughead, sgb)

Changes for 0.7.4

* remove autosave... from console output (sgb)

* allow map skins to depend on each other (add a dependencies.txt file to the skin, with a single line dependencies=skin1,skin2,skin3)  skin1 is the name of the skin (eg pact_of_steel:coal, if pact_of_steel:coal is in a zip file, do not include the .zip)

* better retreat dialog (sgb)

* allow map to have ipc images.  Images should be in the map folder, in a folder called ipcs.  They should be named 1.png, 2.png...  if no png image is found for a given number, a string will be drawninstead. (sgb)

* maps (and skins) can be zip files (sgb)

* map skins can override unit,flag and vc images (sgb)

* map skin directories must now be named original_map_name:Skin, rather than original_map_nameSkin as before (sgb)

* move images and maps to top level folders (these are not on the classpath).  (sgb)

* allow defining where to place ipc markers using ipc_place.txt.  The x,y location is such the point is the bottom left of the image. (sgb)

* allow turn off drawing map names in map.properties using,  map.showTerritoryNames=false (sgb)

* move chat panel to main window for networked games (sgb)

* fixed bug where autosave game would add too many ipcs at start up (sgb)

* fix bug where attacking air units couldnt retreat if all attacking subs moved to attacking sea zone via submerged route (sgb)

* allow clients to save a networked game (sgb)

* game menu to show who is playing what player (sgb)

* when a player (not an observer) leaves the game, the game is saved automatically, and the game ends (sgb)

* observers can join and leave the game (server can optionally ban new observers) (sgb)

* new startup screen (sgb)

* add minimap (map by Clausewitz)

* add delegate execution manager, block delegates from executing while save in progress (sgb)

* make game data lock into a read/write lock, extend the game data lock to history (sgb)

* add random ai (sgb)

* if two players with the same name join the game, add a _1 to the second player (sgb)

* remove ISaveableDelegate, all Delegates are saveable (sgb)

Changes for 0.7.2.4

* move some code into swing event thread (sgb)

* dont let players press dont place once player selection is done (sgb)
 
* should read you need java >= 5.0, not java > 5.0 (sgb)

Changes for 0.7.2.3

* make battle window a dialog (it will always be in front of the main window!) (sgb)

* fix invalid roll count in multiplayer games when all bombers are hit by aa guns (sgb)

* fix null pointer when placing units in sea zone with enemy units (classic game only) (sgb)

* fix null pointer when when selecting null territories during movement (sgb)

Change for 0.7.2.2

* fix convoys (adam_j)

* fix bid purchase (sgb)

* Iron blitz mod (ic)

* fixed string index out of bounds when rolling pbem dice (sgb)

Changes for 0.7.2.1

* fix stat panel in europe (sgb)

* fix bug  1357768  0.7.2 dead defenders firing (sgb)

Change for 0.7.2

* on PBEM screen, add id field (for challenge id) (sgb)

* when clicking on a battle in history, center map on that territory (sgb)

* allow unloading units from a battle zone into newly conquered territories (sgb)

* allow saving games during battles (sgb)

* shift click on a unit (or territory) to select all units in the territory (sgb)

* rename attatchment to attachment (sgb)

* remove singleton image factories, move to UIContext (sgb)

* when retreating from a sea zone, if a fighter has no movement, the fighter gets a 1 movement bonus (sgb)

* battleships can only bombard if they are in a sea zone where transports unloaded (sgb)

* fix bug [ 1277099 ] map refresh problems undoing move with captured aa gun (sgb)

* Japanese victory points for a&a pacific (Adam_J)

changes for 0.7.1

* updated readme and user docs (George_H)

* if we have multiple transports that unloaded troops to an amphibious assault, then the transports 
  retreat from a  naval battle that precedes the amphibious assault, then too many units will retreat (sgb)

* various no pop up movement bugs (sgb)

* fixed chinese tech in big world 1942 map (sgb)

* fixed missing connection from solomon in pacific map (sgb)

* fixed bug [ 1259381 ] Bid purchasing (sgb)

* fixed no pop up movement for scaled units (sgb)

* removed territory attatchments for sea zones in big world map (sgb)

* Fixed missing connections in big world map, north to south brazil, and sea of Okhotsk to West Bering Sea (kc1189)

* More email validation (Adam_J)

* Chinese infantry mechanism added for a&a pacific (Adam_J)

* Convoy Zones implemented (Adam_J)

* Add code for marines (Adam_J)

* Add code in for kamikaze (Adam_J)

* fix bug located http://maddlinks.com/triplea/index.php?showtopic=707 (Adam Jette)

Changes for 0.7.0

* add movement help to help menu (sgb)

* remove hints menu (sgb)

* movement now done without pop up dialogs  (sgb, lnxduk)

* only allow transports to unload units to 1 territory  (sgb)

* fixed bug [ 1238910 ] PBEM mode cannot accept subdomains  (sgb)

* add "click" to select casualties button, many users are confused and dont know to click to select casualties  (sgb)

* reduce network traffic somewhat by more efficient serialization  (sgb)

* autosave now happens at the end of a turn, after combat move and before non combat  (sgb)

* use annotations to determine when to autosave  (sgb)

* change to jdk 1.5, 1.5 is now required to build and to run  (sgb)

* fix bug where versions like 0.6.0.1 would be displayed as 0.6.1  (sgb)

Changes for 0.6.0.1

* fix bug [ 1225276 ] Aircraft unable to attack or land (sgb)

Changes for 0.6.0

* updated developer docs, incomplete for now (George_H)

* draw a line under overflow units so you can tell what belongs in a territory (sgb)

* fixed bug where you could retreat subs if all your opponents destroyers were destroyed in one round of combat (sgb)

* fixed bug where damaged battleships would not repair while viewing history (sgb)

* fixed small map refresh (whole map goes white) when switching skins (sgb)

* fixed bug where sometimes dice would not show up on the select casualties panel (sgb)

* removed "Heavy Bombers Pick best of X Dice" option from classic and wandering head big world, it didnt work (sgb)

* Fixed bug where transport moves could be undone before moves where the transport had been loaded/unloaded (sgb)

Changes for 0.5.4

* fixed bug where units could blitz through territories with an aa gun if they blitzed in 2 steps (4th edition only) (sgb)

* fixed bug [ 1188411 ] Missing client text (Chat window) 5.2.2 (sgb)

* fixed bug [ 1205387 ] Saving game during combat 0.5.3 (sgb)

* fixed bug [ 1205775 ] 0.5.3 eMail Bug - hyphens not allowed in emails (sgb)

* fixed bug [ 1205504 ] Units can land in amphibious assaults when transport is sunk (sgb)

* fixed bug [ 1198828 ]Heavy Bomber Tech Broken 0.5.3 (sgb)

Changes for 0.5.3

* added europe and pacific maps (incomplete versions) by iron cross (George_H)

* added extra dice statistics such as, median, variance, and standard deviation (George_H)

* fix bug [ 1023326 ] Fig Landing Problem, J1 (sgb)

* more flexible validation for planes landing on carriers (sgb)

* add stat export menu item Game->Export Game Stats (sgb)

* upgraded plastic look and feel to version 1.3.1 (sgb)

* add vc drawing and added vc cities to stats (sgb)

* better email address ui and validation, allow up to 5 emails in to and copy (sgb)

* added white factory images (zero_pilot)

* added drawing capitol markers (capitol markers contributed by black elk) (sgb)

* added junit.jar file to lib and removed it from .ant.properties (sgb)

* fixed bug  [ 1070176 ] Mistakes in calculating Battlescore (change in TUV) (sgb)

* fixed bug [ 1116632 ] v0.5.1.1 TripleA skipping battle in Borneo (sgb)

* fixed bug [ 1145318 ] Another Error on 5.2.2 (sgb)

* fixed bug [ 1157717 ] 0.5.2.2 Error with question : Sumerge subs (sgb)

* fixed bug [ 1175467 ] game "stuck" when doing multiple battles with same units (sgb)

* fixed bug [ 1171596 ] Rocket Tech bug v0.5.2.2, we now always ask what territory to attack with rockets, even if there is only one choice, this allows the user to decline a rocket attack (sgb)

* during battles the dice are sorted according to unit type so that when you review the dice rolls, you can tell what unit rolled for which dice (sgb)

* fix bug [ 1144356 ] alter email header on PBEM (this is really a feature request) (sgb)

* added new chinese units and cruiser, halftrack, marine units (iron_cross)

* fixed [ 1158469 ] Missing units in Purchase Menu when odd number of choices (sgb)

* you can now specify victory cities in xml using a territory attachement (sgb)

* added tile map drawing (sgb)

* add a copy to clipboard button on the console (sgb)

* if available, console will print stack traces when enumerating threads (sgb)

* put neutral player color in map.properties (sgb)

Changes for 0.5.2.2

* fixed Dont play button on client screen. (sgb)

* threading fixes. (sgb)

Changes for 0.5.2

* add switch in map.properties to disable scrolling map around the edges (sgb)
 
* added scripted random for debugging (sgb)

* added new map by WanderingHead (wandering head)

* add confirmation prompt when exiting the game (sgb)

* jdk 1.4 - 1.5 compatability (sgb)

* Add has relief property to map.properties (sgb)

* Add default unit scroll size to map.properties (sgb)

* Changes to make TripleA compile under Sun JDK 1.5.x (George_H)

* Added better unix shell scripts for TripleA, thanks DMan for the scripts (George_H)

* Added better path search so TripleA can run from any directory (sgb)

* Now all map utils have proper "save as" dialogs (George_H)

* Added new class to prompt user to select a directory so map utils won't save files to a hardcoded dir (George_H)

* Define player colour in map.properties to allow easy modification and adding new players (sgb)

* Added option to limit ipcs lost in a territory during one round. This is necessary to implement LHTR ruleset. (Ali Ibrahim)

* Fixed bug in Irony PBEM random source: It did not use the max parameter passed to the random methods. This fixes the 4th edition AA casualty selection problem in PBEM. (Ali Ibrahim)

* Added new technology activation delegate to allow control of when technologies actually take effect. This is used to allow delay of technology activation in LHTR. (Ali Ibrahim)

* Changed mouse behavior such that only the left button is used to select a territory to put units in. (Ali Ibrahim)

* Added more options for unit size using submenu. (Ali Ibrahim)

* Changed ordering of properties in the launcher properties tab to use ordering in game XML file. (Ali Ibrahim)

* Added Map Skins code to allow multiple (1 and greater) map skins to be used for each game based on a directory search pattern. Skins must be in maps folder with game name as prefix (ie. revisedMySkin). (Beagle)

* Changed how bombardment works. Now users pick where to bombard before any battles are resolved. This allows users not to bombard with a unit (for example if they wish to move it during non-combat) by picking "None". This also fixes the bug where a a unit could retreat from a battle and bombard in the same turn. It also allows user to divide their bombardment shots however they like when there are multiple bombardment targets. (Ali Ibrahim)

* Fixed bug #1067768 concerning the border of seazone 27 and Belgian Congo. (George_H)

* Fixed bug #1067331 by removing the connection between seazone 51 and 56 for Pact of Steel mod. (George_H)

* Fixed bug #1067073 by removing the connection between seazone 15 and 16 for Pact of Steel mod. (George_H)

* Fixed bug #1043826 concerning missing sea zone border & missing pixles on border. (George_H)

* Added channel and remote messengers. (sgb)

* Added game vault. (sgb)

* Fixed bug [ 1053071 ] No non-combat movement (sgb)

* Fixed bug where properties werent being updated on client (sgb)

* Fixed bug [ 991810 ] Internet Bid Problem (sgb)

* Fixed bug [ 1051937 ] Number of bid ipcs displayed (sgb)

* Fixed bug [ 1102812 ] flag image names not based on xml names (sgb)

* Fixed bug [ 1102225 ] Error by adding better error messages (sgb)

* Store pbem emails in saved game (sgb)

* Fixed bug [ 1095206 ] AA Firing too quickly v0.5.1 (sgb)

* Fixed bug [ 1092852 ] bug in 2bysea Version .5.1 (sgb)

* Fixed bug [ 1021352 ] advanced tech prob (sgb)

* Fixed bug [ 1021350 ] Tech Prompt (sgb)

* Fixed bug [ 1006050 ] Unable to conquer territories (sgb)

* Fixed bug [ 1021351 ] No Buy Confirmation (sgb)

* Add micro to Version, ie version can now be xx.xx.xx.xx (sgb)

Changes for 0.5.1

* Fixed bug where defending transported units were not correctly removed when their transports were killed. (Ali Ibrahim)

* Fixed bug where transported AA guns fired in naval battles. (Ali Ibrahim)

* Added a new developer document with map utils info. (George_H)

* Added menu option to use small unit images on map. (Ali Ibrahim)

* Large improvement and re-organizing of user documentation. (George_H)

* Fully implemented Pact Of Steel mod (by Black Elk/Beagle). (George_H)

* Improved map directory structures and code for triplea concerning TerritoryData class. (George_H)

* Small iteration fix applied to PolygonGrabber to prevent crash. (Beagle)

* Improve all map utilities so they are user friendly and better to use. (George_H)

* Fixed bug in 4th edition where air units could define retreat paths (they still can in classic). (Ali Ibrahim)

* Added MersenneTwister Thread Safe (MT199937) Random Number Generator with Permission from Sean Luke. (George_H)

* Added Low Luck option following DAAK rules. However, the low luck rules were not implemented for sbr's and tech rolls. Also it is incompatible with the heavy bomber downgrade option. (Ali Ibrahim)

* Allowed transports carrying aa guns to move in combat, although the aa guns still cannot be loaded/unloaded in the combat move. (Ali Ibrahim)

* Fixed map bugs (missing connection between sz25, sz43, wrong connection between sz51, sz56, misspelling of Angola). (Ali Ibrahim)

* Added logic to prefer routes without neutral countries. (Ali Ibrahim)

* Fixed bug which did not allow placement of bid units. (Ali Ibrahim)
 
* Fixed bug which did not allow placement of units in classic. (Ali Ibrahim)

* Fixed bug which did not allow placement of AA guns correctly. (Ali Ibrahim)

* Fixed bug which did not correctly reload transports which had conducted an amphibious assault and then retreated. (Ali Ibrahim)

* Added capability to bid for allies for 4th edition game. (Ali Ibrahim)

Changes for 0.5.0

* Added TUV (total unit value) column in statistics panel. Added TUV lost in battle as part of battle end message. (Ali Ibrahim)

* Fixed bug in statistics table when adding a player such as Italy (George_H).

* Added logic to check production limits to display in production panel. (Kevin Sanders).

* Added logic to not consider moving land units into water if there are no transports there. (Ali Ibrahim)

* Added game defintion file, flags, color for Italian player. (George_H).

* Fixed bug where allied air units which are cargo attacked. (Ali Ibrahim)

* Changed game logic to allow destroyers to pass over submerged subs in 4th edition. (Ali Ibrahim)

* Fixed bug which didn't allow fighters to consider landing in gibralator due to issue with pathing and neutrals. (Ali Ibrahim)

* Added warning for users using Java 1.5 about some serialization problems which cause an incompatibility with saved games in Java 1.4. (George_H)

Changes for 0.4.9

* Fix for bug #1010428 bypassing the unit selection popup message when there is only 1 unit to be moved. (Ali Ibrahim)

* AI for 2nd edition rules added,experimental. (Sean Bridges/Troy)

* Stack trace when starting triplea after a saved game fixed. (Sean Bridges)

* Fixed bug when defending subs get first strike fire, even if an enemy destroyer is present. (Sean Bridges)

* Changes in Battle Panel relating to SWING event thread to stop game from freezing in battle mode. (Sean Bridges)

* Fix for Bug #1001946 fixed for units crossing water. Now crossesWater only returns true if the route starts and ends on land and also contains a water territory. (James Damour)

* Fixes for Points 1,4 (and possibly 3) for Bug #1003736. (Ali Ibrahim)

* Clean up of neutrality violation messages (4th ed). (Ali Ibrahim)

* Now defending planes can land in any adjacent territory if their carrier is lost in combat (4th ed). (Ali Ibrahim)

Changes for 0.4.8

* Automatic casualty selection has been also added (Ali Ibrahim)

* Drag scrolling and mouse wheel scrolling (since 0.4.7).  (lnxduk)

* TripleA Chat improvements. (lnxduk)

* Fix for null network interface on IRIX 6.5 OS. (George_H)

